# PasswordPolicy

A password policy describes a set of rules regarding passwords. Authorization is controlled via JWT.

This tag groups all operations for passwordpolicy.

## Retrieve all PasswordPolicy

> This endpoint enables retrieving all PasswordPolicy using\
> pagination and optional filters.<br>

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - IAM Identity Password Policies API","version":"1.0.0"},"tags":[{"name":"PasswordPolicy","description":"A password policy describes a set of rules regarding passwords. Authorization is controlled via JWT.\n\nThis tag groups all operations for passwordpolicy.\n"}],"servers":[{"url":"https://iam.ionos.com"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"parameters":{"effectivePolicy":{"name":"effectivePolicy","in":"query","description":"When set to `true`, then the policy that is in effect for the actor's contract (as defined by the JWT) is returned.\nATM this has the only effect that if no policy is defined for the user/contract, then the IONOS default policy is returned.\n","required":false,"schema":{"type":"boolean"}}},"schemas":{"PasswordPolicyReadList":{"allOf":[{"type":"object","required":["id","type","href"],"properties":{"id":{"description":"ID of the list of PasswordPolicy resources.","type":"string","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["collection"]},"href":{"description":"The URL of the list of PasswordPolicy resources.","type":"string"},"items":{"description":"The list of PasswordPolicy resources.","type":"array","items":{"$ref":"#/components/schemas/PasswordPolicyRead"}}}}]},"PasswordPolicyRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the PasswordPolicy.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["passwordpolicy"]},"href":{"description":"The URL of the PasswordPolicy.","type":"string"},"metadata":{"$ref":"#/components/schemas/Metadata"},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"PasswordPolicy":{"type":"object","required":["description","minLength"],"properties":{"description":{"type":"string","description":"Human readable description of the policy.","maxLength":1024},"minLength":{"description":"Minimum number characters","minimum":5,"type":"integer"},"minNumberChars":{"description":"Lower characters are considered to be all in range of [0-9]","type":"integer","default":0,"minimum":0},"minUpperChars":{"description":"Lower characters are considered to be all in range of [A-Z]","type":"integer","default":0,"minimum":0},"minLowerChars":{"description":"Lower characters are considered to be all in range of [a-z]","type":"integer","default":0,"minimum":0},"minSpecialChars":{"description":"Special characters are considered to be all characters that are not in the ASCII ranges [a-zA-Z0-9]","type":"integer","default":0,"minimum":0}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/passwordpolicies":{"get":{"operationId":"passwordpoliciesGet","summary":"Retrieve all PasswordPolicy","description":"This endpoint enables retrieving all PasswordPolicy using\npagination and optional filters.\n","parameters":[{"$ref":"#/components/parameters/effectivePolicy"}],"tags":["PasswordPolicy"],"responses":{"200":{"description":"Returned all requested PasswordPolicy successfully.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordPolicyReadList"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Create PasswordPolicy

> Creates a new PasswordPolicy.\
> \
> The full PasswordPolicy needs to be provided to create the object.\
> Optional data will be filled with defaults or left empty.<br>

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - IAM Identity Password Policies API","version":"1.0.0"},"tags":[{"name":"PasswordPolicy","description":"A password policy describes a set of rules regarding passwords. Authorization is controlled via JWT.\n\nThis tag groups all operations for passwordpolicy.\n"}],"servers":[{"url":"https://iam.ionos.com"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"PasswordPolicyCreate":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"PasswordPolicy":{"type":"object","required":["description","minLength"],"properties":{"description":{"type":"string","description":"Human readable description of the policy.","maxLength":1024},"minLength":{"description":"Minimum number characters","minimum":5,"type":"integer"},"minNumberChars":{"description":"Lower characters are considered to be all in range of [0-9]","type":"integer","default":0,"minimum":0},"minUpperChars":{"description":"Lower characters are considered to be all in range of [A-Z]","type":"integer","default":0,"minimum":0},"minLowerChars":{"description":"Lower characters are considered to be all in range of [a-z]","type":"integer","default":0,"minimum":0},"minSpecialChars":{"description":"Special characters are considered to be all characters that are not in the ASCII ranges [a-zA-Z0-9]","type":"integer","default":0,"minimum":0}}},"PasswordPolicyRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the PasswordPolicy.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["passwordpolicy"]},"href":{"description":"The URL of the PasswordPolicy.","type":"string"},"metadata":{"$ref":"#/components/schemas/Metadata"},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/passwordpolicies":{"post":{"operationId":"passwordpoliciesPost","summary":"Create PasswordPolicy","tags":["PasswordPolicy"],"description":"Creates a new PasswordPolicy.\n\nThe full PasswordPolicy needs to be provided to create the object.\nOptional data will be filled with defaults or left empty.\n","requestBody":{"description":"PasswordPolicy to create.","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordPolicyCreate"}}}},"responses":{"201":{"description":"PasswordPolicy successfully created.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordPolicyRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Retrieve PasswordPolicy

> Returns the PasswordPolicy by ID.

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - IAM Identity Password Policies API","version":"1.0.0"},"tags":[{"name":"PasswordPolicy","description":"A password policy describes a set of rules regarding passwords. Authorization is controlled via JWT.\n\nThis tag groups all operations for passwordpolicy.\n"}],"servers":[{"url":"https://iam.ionos.com"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"PasswordPolicyRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the PasswordPolicy.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["passwordpolicy"]},"href":{"description":"The URL of the PasswordPolicy.","type":"string"},"metadata":{"$ref":"#/components/schemas/Metadata"},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"PasswordPolicy":{"type":"object","required":["description","minLength"],"properties":{"description":{"type":"string","description":"Human readable description of the policy.","maxLength":1024},"minLength":{"description":"Minimum number characters","minimum":5,"type":"integer"},"minNumberChars":{"description":"Lower characters are considered to be all in range of [0-9]","type":"integer","default":0,"minimum":0},"minUpperChars":{"description":"Lower characters are considered to be all in range of [A-Z]","type":"integer","default":0,"minimum":0},"minLowerChars":{"description":"Lower characters are considered to be all in range of [a-z]","type":"integer","default":0,"minimum":0},"minSpecialChars":{"description":"Special characters are considered to be all characters that are not in the ASCII ranges [a-zA-Z0-9]","type":"integer","default":0,"minimum":0}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/passwordpolicies/{passwordPolicyId}":{"get":{"operationId":"passwordpoliciesFindById","summary":"Retrieve PasswordPolicy","tags":["PasswordPolicy"],"description":"Returns the PasswordPolicy by ID.","parameters":[{"name":"passwordPolicyId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the PasswordPolicy."}],"responses":{"200":{"description":"Getting PasswordPolicy was successful.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordPolicyRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Ensure PasswordPolicy

> Ensures that the PasswordPolicy with the provided ID is created or modified.\
> The full PasswordPolicy needs to be provided to ensure\
> (either update or create) the PasswordPolicy. Non present data will\
> only be filled with defaults or left empty, but not take\
> previous values into consideration.<br>

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - IAM Identity Password Policies API","version":"1.0.0"},"tags":[{"name":"PasswordPolicy","description":"A password policy describes a set of rules regarding passwords. Authorization is controlled via JWT.\n\nThis tag groups all operations for passwordpolicy.\n"}],"servers":[{"url":"https://iam.ionos.com"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"PasswordPolicyEnsure":{"type":"object","required":["id","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the PasswordPolicy.","format":"uuid"},"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"PasswordPolicy":{"type":"object","required":["description","minLength"],"properties":{"description":{"type":"string","description":"Human readable description of the policy.","maxLength":1024},"minLength":{"description":"Minimum number characters","minimum":5,"type":"integer"},"minNumberChars":{"description":"Lower characters are considered to be all in range of [0-9]","type":"integer","default":0,"minimum":0},"minUpperChars":{"description":"Lower characters are considered to be all in range of [A-Z]","type":"integer","default":0,"minimum":0},"minLowerChars":{"description":"Lower characters are considered to be all in range of [a-z]","type":"integer","default":0,"minimum":0},"minSpecialChars":{"description":"Special characters are considered to be all characters that are not in the ASCII ranges [a-zA-Z0-9]","type":"integer","default":0,"minimum":0}}},"PasswordPolicyRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the PasswordPolicy.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["passwordpolicy"]},"href":{"description":"The URL of the PasswordPolicy.","type":"string"},"metadata":{"$ref":"#/components/schemas/Metadata"},"properties":{"$ref":"#/components/schemas/PasswordPolicy"}}},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Conflict":{"description":"### Conflict\nThe UUID is already taken by another party, follow the guides to generate UUIDs uniquely.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/passwordpolicies/{passwordPolicyId}":{"put":{"operationId":"passwordpoliciesPut","summary":"Ensure PasswordPolicy","tags":["PasswordPolicy"],"description":"Ensures that the PasswordPolicy with the provided ID is created or modified.\nThe full PasswordPolicy needs to be provided to ensure\n(either update or create) the PasswordPolicy. Non present data will\nonly be filled with defaults or left empty, but not take\nprevious values into consideration.\n","parameters":[{"name":"passwordPolicyId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the PasswordPolicy."}],"requestBody":{"description":"update PasswordPolicy","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordPolicyEnsure"}}}},"responses":{"200":{"description":"PasswordPolicy successfully updated.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordPolicyRead"}}}},"201":{"description":"PasswordPolicy successfully ensured.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PasswordPolicyRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Delete PasswordPolicy

> Deletes the specified PasswordPolicy.

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - IAM Identity Password Policies API","version":"1.0.0"},"tags":[{"name":"PasswordPolicy","description":"A password policy describes a set of rules regarding passwords. Authorization is controlled via JWT.\n\nThis tag groups all operations for passwordpolicy.\n"}],"servers":[{"url":"https://iam.ionos.com"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}},"schemas":{"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}}},"paths":{"/passwordpolicies/{passwordPolicyId}":{"delete":{"operationId":"passwordpoliciesDelete","summary":"Delete PasswordPolicy","tags":["PasswordPolicy"],"description":"Deletes the specified PasswordPolicy.","parameters":[{"name":"passwordPolicyId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the PasswordPolicy."}],"responses":{"202":{"description":"Deleting PasswordPolicy was successful."},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```
